package Weblog::Auth;

########################################################################
# LOAD MODULES                                                         #
########################################################################
BEGIN {
    use strict;
    use Carp;
    use vars qw($VERSION $AUTOLOAD @ISA);
    $VERSION = '0.1';
    @ISA = qw();
}

########################################################################
# CLASS INITIALIZATION                                                 #
########################################################################
# list of valid class attributes
my %ok_fields = (
		 
	       );

sub new {
#**********************************************************************#
    # determine class name
    my $pkg = shift;
    my $class = ref($pkg) || $pkg;
    
    # build new instance of object
    my $self = bless 
    {
        _fields => \%ok_fields, 
        %ok_fields
        }, $class;
    
    # initalize variables in object if values were passed
    $self->_initialize(@_);
    
    # return pointer to the new object
    return $self;
#**********************************************************************#
}

sub _initialize {
#**********************************************************************#
    my ($self,$file) = (@_);
    #$self->load_config($file) if -e $file;
#**********************************************************************#
}

sub AUTOLOAD {
#**********************************************************************#
    my $self = shift;
    my $type = ref($self) || croak "$self is not an object\n";
    my $name = $AUTOLOAD;
    $name =~ s/.*://;
    unless (exists $self->{_fields}->{$name}) {
        croak "Unregistered entity: Can't access $name field in object of class $type";
    }
    if (@_) {
        return $self->{$name} = shift;
    } else {
	return $self->{$name};
    }
#**********************************************************************#
}

sub DESTROY {
#**********************************************************************#
    my $self = shift;
    $self = undef;
#**********************************************************************#
}

sub is_authorized {
#**********************************************************************#
# SYNTAX: &is_authorized ($channel, $user);                            #
# PARAMS: $channel - name of the channel to save                       #
#         $user - name of the user requesting the channel              #
# RETURN: 1 - the user is authorized to access the channel             #
#         0 - the user is not authorized to access the channel         #
#**********************************************************************#
    my ($self,$channel,$user) = @_;
    my $authorized = 0;

    if ($self->config->{'channel'}->{$channel}->{'users'}->{$user}) {
	$authorized = 1;
    }
    
    return $authorized;
#**********************************************************************#
# END SUBROUTINE: &is_authorized ($channel, $user);                    #
#**********************************************************************#
}


1;
