#!/usr/bin/perl -w

use strict;
use Frontier::Daemon;
use Frontier::RPC2;
use POSIX 'setsid';
use MIME::Base64;  
use Weblog;   

my $config_file = '../config/config.xml';
#&daemonize;
my $weblog = new Weblog($config_file);
my $server = new Frontier::Daemon (
				   LocalPort => 8007,
				   methods   => {
				       'list_channels'    => \&list_channels,
				       'retrieve_channel' => \&retrieve_channel
				       });  


sub daemonize {
#**********************************************************************#
# SYNTAX: &daemonize;                                                  #
# PARAMS:                                                              #
# RETURN:                                                              #
#**********************************************************************#
    chdir '/' or die "Can't chdir to /: $!";
    #open STDIN, '/dev/null' or die "Can't read /dev/null: $!";
    #open STDOUT, '>/dev/null' or die "Can't write to /dev/null: $!";
    defined(my $pid = fork) or die "Can't fork: $!";
    exit if $pid;
    setsid or die "Can't start a new session: $!";
    #open STDERR, '>&STDOUT' or die "Can't dup stdout: $!";
#**********************************************************************#
# END SUBROUTINE: &daemonize;                                          #
#**********************************************************************#
}       

sub list_channels {
#**********************************************************************#
# SYNTAX: &list_channels;                                              #
# PARAMS:                                                              #
# RETURN:                                                              #
#**********************************************************************#
    my @channels = $weblog->list_channels;
    my @lchannels;
    foreach my $channel (@channels) {
	push(@lchannels,$channel->{'name'});
    }
    
    return [@lchannels];
#**********************************************************************#
# END SUBROUTINE: &list_channels;                                      #
#**********************************************************************#
}       

sub retrieve_channel {
    # convert rss channel to hash and arrays
    my $channel_name = shift;
    my $channel = new Weblog::Channel($weblog,$channel_name);
    #return $channel;
    return {
	channel => {
	    'title' => 'bahaha',
	    'description' => 'dada'
	},
	items => [
		  'item1',
		  'item2'
		  ]
    };
}
